import docopt, logging, os, sequtils

import strawboss/private/util
import strawboss/configuration
import strawboss/core
import strawboss/server

let SB_VER = "0.1.0"

when isMainModule:

  if logging.getHandlers().len == 0:
    logging.addHandler(newConsoleLogger())

  var cfg = loadStrawBossConfig("strawboss.config.json")
  if not existsDir(cfg.artifactsRepo):
    info "Artifacts repo (" & cfg.artifactsRepo & ") does not exist. Creating..."
    createDir(cfg.artifactsRepo)

  cfg.artifactsRepo = expandFilename(cfg.artifactsRepo)
  
  let doc = """
Usage:
  strawboss serve
  strawboss run <project> <step> [-r <ref>]"""

  let args = docopt(doc, version = "strawboss v" & SB_VER)

  if args["run"]:

    let projName = $args["<project>"]
    let stepName = $args["<step>"]
    let buildRef = if args["-r"]: $args["<ref>"] else: nil

    try: core.runStep(cfg, projName, stepName, buildRef)
    except:
      fatal "strawboss: " & getCurrentExceptionMsg()
      quit(QuitFailure)

  elif args["serve"]: server.start(cfg)
